clc, clear


% initial
uavspan = 2.795;
uavchord = 0.351; 
uavS = 0.982; 
% uavS = 0.7539; 
uavmass = 8.165; 
uavCD0 = 0.022; 
uavApolar = 0.057; 
envg = 9.81; 
envrho0 = 1.225; 
Ct = 0.0984; 
Cm = 0.0068; 
Dp = 0.381; %cm
Kv = 465; 
Umax = 22.2; 
Kdecay = 12; 


V = 5:0.1:80;
% Calculate P_px 
% Q = 0.5 * envrho0 * uavS * V.^2;
P_re = @(V) uavCD0 * 0.5 * envrho0 * uavS * V.^2 + uavApolar * ( uavmass * envg )^2 ./ (0.5 * envrho0 * uavS * V.^2 );


% Calculate P_ky_V
N = Kv * Umax;
P_av = Ct * envrho0 * (N / 60)^2 * Dp^4;
P_av_V = @(V)P_av - Kdecay * V /sqrt(P_av);

F = @(V) P_av_V(V) - P_re(V);

% calculate V_max
Vmax = fsolve(F,[0.1,50]);
Vmax = Vmax(2); 
% calculate V_lt
G = uavmass*envg;
V_lt = sqrt(2*G/(envrho0*uavS*sqrt(uavCD0/uavApolar)));
% calculate V_ld
V_ld = sqrt(2*G/(envrho0*uavS*sqrt(uavCD0/3/uavApolar)));

% Draw
figure()
plot(V,P_re(V),'r-',V,P_av_V(V),'b--')
axis([0 90 0 100]); 
legend('需用推力曲线', '可用推力曲线')
xlabel('飞行速度V(m/s)')
ylabel('力F(N)')
grid on
