clc, clear

% initial
uavspan = 2.795; 
uavchord = 0.351; 
% uavS = 0.2:0.1:3; 
uavS = 0.982; 
% uavmass = 5:0.1:20; 
uavmass = 8.165; 
% uavCD0 = 0.022; 
uavCD0 = 0.005:0.005:0.1;
% uavlambda = 1:0.5:16;
% uavApolar = 1./(uavlambda*pi*0.7); 
uavApolar = 0.057; 
envg = 9.81; 
envrho0 = 1.225; 
Ct = 0.0984;
Cm = 0.0068; 
Dp = 0.381; %cm
Kv = 465;
Umax = 22.2;
Kdecay = 12;

% Maximum level flight speed
Vmax_list = [];
for uavCD0i = uavCD0 % 修改这里
    V = 5:0.1:80;
    % Calculate P_px 
    P_px = @(V) uavCD0i * 0.5 * envrho0 .* uavS * V.^2 + uavApolar * ( uavmass .* envg )^2 ./ (0.5 * envrho0 .* uavS * V.^2 );

    % Calculate P_ky_V
    N = Kv * Umax;
    P_ky = Ct * envrho0 * (N / 60)^2 * Dp^4;
    P_ky_V = @(V)P_ky - Kdecay * V /sqrt(P_ky);

    F = @(V) P_ky_V(V) - P_px(V);

    % Maximum level flight speed
    Vmax = fsolve(F,[0.1,50]);
    Vmax_list(end+1) = Vmax(2);
end

% calculate V_ld
G = uavmass.*envg;
V_yh = @(G)sqrt(2*G./(envrho0*uavS*sqrt(uavCD0/3./uavApolar)));

% Draw figure
% figure()
% plot(uavS,Vmax_list,'b--',uavS,V_yh(G),'r-')
% axis([0 3.1 0 70]); 
% legend('最大平飞速度', '远航速度')
% xlabel('机翼面积（m^2）')
% ylabel('飞行速度V(m/s)')
% grid on

% figure()
% plot(uavmass,Vmax_list,'b--',uavmass,V_yh(G),'r-')
% axis([4 21 0 50]); 
% legend('最大平飞速度', '远航速度')
% xlabel('总质量（kg）')
% ylabel('飞行速度V(m/s)')
% grid on

% figure()
% plot(uavlambda,Vmax_list,'b--',uavlambda,V_yh(G),'r-')
% axis([0 16.5 0 50]); 
% legend('最大平飞速度', '远航速度')
% xlabel('展弦比')
% ylabel('飞行速度V(m/s)')
% grid on

figure()
plot(uavCD0,Vmax_list,'b--',uavCD0,V_yh(G),'r-')
axis([0 0.105 0 50]); 
legend('最大平飞速度', '远航速度')
xlabel('零升阻力系数')
ylabel('飞行速度V(m/s)')
grid on
